/***************************************************************************
 *   Copyright (C) 2004 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NICOLAINPUT_H
#define NICOLAINPUT_H

#define Uses_SCIM_ICONV
#define Uses_SCIM_CONFIG_BASE
#include <map>
#include <scim.h>
#include <scim_iconv.h>
#include <scim_event.h>
#include "preeditor.h"
#include <honokasetupcore.h>

#define HONOKA_CONFIG_NICOLAINPUT_LSHIFT            "/IMEngine/Honoka/NicolaInput/LeftShift"
#define HONOKA_DEFAULT_NICOLAINPUT_LSHIFT           "Muhenkan"
#define HONOKA_CONFIG_NICOLAINPUT_RSHIFT            "/IMEngine/Honoka/NicolaInput/RightShift"
#define HONOKA_DEFAULT_NICOLAINPUT_RSHIFT           "Henkan"
#define HONOKA_CONFIG_NICOLAINPUT_SPTIMER           "/IMEngine/Honoka/NicolaInput/SimultaneouslyPressTimer"
#define HONOKA_DEFAULT_NICOLAINPUT_SPTIMER          100
#define HONOKA_CONFIG_NICOLAINPUT_TABLE_FILE        "/IMEngine/Honoka/NicolaInput/TableFile"
#define HONOKA_DEFAULT_NICOLAINPUT_TABLE_FILE       ""


using namespace std;
using namespace scim;

/**
@author TAM(Teppei Tamra)
*/
namespace Honoka {

class NicolaKey {
public:
    WideString noShift;
    WideString leftShift;
    WideString rightShift;
};

class NicolaInput : public PreEditor {
public:
    NicolaInput(ConfigPointer cfg);

    ~NicolaInput();
    virtual bool inputEvent(const KeyEvent &key);
    virtual String getName();
    virtual String getModeName();
    virtual String getPropertyName();
    virtual bool keyEventHook(const KeyEvent &key);
    static HonokaSetupCorePage *setup();

protected:
    bool LShift;
    bool RShift;
    KeyEventList LShiftKey;
    KeyEventList RShiftKey;
    unsigned int delay;
    map<KeyEvent,NicolaKey> keymap;
    WideString vsc;
    WideString svsc;
    WideString vs1;
    WideString vs2;
    WideString svs1;
    WideString svs2;
    long bkt;
    KeyEvent bk;
protected:
    bool loadTable(const String &filename);
};
}
#endif
